<?php

// Ce fichier ne sera execute qu'une fois
if (defined("_INC_CACHE")) return;
define("_INC_CACHE", "1");
include_ecrire('inc_serialbase.php3');

function squelette_obsolete($naissance, $vetuste)
{
  // vrif de la date de validit par rapport  la source
  // (ici le champ VETUSTE) et les fonctions agissant sur le compilateur
  // (celui-ci est suppos ne changer qu' l'installation)

  return (($GLOBALS['recalcul_squelettes'] == 'oui')
	  OR ((filemtime($vetuste) > $naissance)
	      OR ((file_exists("ecrire/mes_options.php3")
		   AND (filemtime("ecrire/mes_options.php3") > $naissance)))
	      OR ((file_exists("mes_fonctions.php3")
		  AND (filemtime("mes_fonctions.php3") > $naissance)))));
}

function page_obsolete($naissance, $vetuste)
{
  // vrif de la date de validit par rapport  la dure de vie
  return ((time() > ($naissance + $vetuste)) and timeout(false,false));
}

function cv_du_cache($hache)
{
      $r = spip_fetch_array(spip_query("
SELECT	naissance
FROM	spip_caches
WHERE	hache = 0x$hache"));
      return ($r['naissance'] ? $r['naissance'] : 0);
}

function ramener_cache($cache, $obsolete, $table, $delais, $dodo=0)
{
  // attendre son tour
  while (!spip_get_lock($cache, 1)); 

  //cache dj compil ?
  $r = spip_fetch_array(spip_query("
SELECT texte,process_ins,naissance,vetuste
FROM $table
WHERE hache = 0x$cache"));
  if ($r)
    { 
      // oui, mais quel est son age ?
      $t = $r['naissance'];
      // age nul ==> un autre processus fait le boulot en ce moment.
      // Si ce perdant de PHP connaissait Waitpid, j'aurais pu synchroniser.
      // L je suis oblig de dormir 1 seconde systmatiquement
      // et d'estimer que s'il n'y a rien de neuf au rveil, 
      // c'est que le processus est mort et ne finira pas le boulot.
      // Avec un rendez-vous j'aurais meme pu augmenter la priorit du cache.
      if (!$t)
	{
	  spip_release_lock($cache);
	  if  ($dodo)
	    return('');
	  else
	    {
	      sleep(1);
	      return ramener_cache($cache, $obsolete, $table, $delais, 1);
	    }
	}
      // test de vtust du cache 
      if (!$obsolete($t, $r['vetuste']))
	{  // tout est ok. On prcise le type du cache (pas encore exploit)
	  spip_release_lock($cache);
	  $r['type'] = 'string';
	  return($r);
	}
      // trop vieux ! liminer ces dpendances
      spip_log("$cache $obsolete obsolete depuis " . (time() -$t) . " secondes");
      supprime_cache_dependant(array("0x$cache"));
    }
  // On annonce qu'on recalcule en le declarant d'age nul
  // On met aussi un texte standard pour que l'internaute sache quoi
  // faire en cas de pb (ne devrait pas arriver cependant)
  spip_query("
INSERT INTO $table (hache, naissance, texte)
VALUES (0x$cache, 0, 'Si votre navigateur affiche ce message, c\'est que $table est incomplte, suite  la disparition du processus " . getmypid() . ". Ressayez')");
  spip_release_lock($cache);
  return '';
}

function ramener_squelette($squelette)
{
  // L'valuation du squelette definit les fonctions associees aux boucles,
  // et fournit le nom de la fonction principale

  $c = md5($squelette);
  $r = ramener_cache($c, 'squelette_obsolete', 'spip_squelettes', 0);
  if ($r) eval($r['texte']);

  if (!$func_squelette_executer) {

    // Cache absent, effac ou erron ==> compilation
    // L'internaute s'impatientant, cacher en priorit basse, 

    include_local("inc-calcul-squel.php3");
    $timer_a = explode(" ", microtime());
    $r = calculer_squelette($squelette);
    $timer_b = explode(" ", microtime());
    $timer = ceil(1000*($timer_b[0] + $timer_b[1]-$timer_a[0]-$timer_a[1]));
    spip_log("Squelette $squelette:\t($c) " . strlen($r) . " octets, $timer ms");
    /* pour la mise au point
    if (file_exists("ecrire/data/.skeldif")) 
      {$f=fopen("ecrire/data/.skeldif", "a"); 
       fwrite($f,"\n############skeldif $c :$squelette\n");
       fwrite($f,$r);
       fclose($f);} //*/
    // pas UPDATE: prcaution si processus prcdent avort.
  spip_query("
DELETE FROM  spip_squelettes
WHERE	hache=0x$c
");
    spip_query("
INSERT INTO spip_squelettes (naissance, vetuste, hache, texte)
VALUES (UNIX_TIMESTAMP(), '$squelette.html', 0x$c,'" . addslashes($r) . "')
");
    eval($r);
  }
  return $func_squelette_executer;
}

function ecrire_cache($appel, $cache, $page, $delais) {
  $infosurpage = $page['invalideurs'];
  $texte = $page['texte'];
  // se prmunir contre les recalculs et autres processus en force
  spip_query("
DELETE FROM spip_caches 
WHERE	hache=0x$cache
");
  $n = strlen($texte);
  if ($n)  {
    spip_log("ecriture de $appel ($cache) $n octets (cache: $delais ms)");
    /* pour la mise au point
      if (file_exists("ecrire/data/.cachedif")) 
	{$f=fopen("ecrire/data/.cachedif", "a"); 
	fwrite($f,"############skeldif $cache :$appel\n");
	fwrite($f,"############length: $n  delai :$delais time: ". time() . "\n");
	fwrite($f,$texte);
	fclose($f);} //*/
       spip_query("
INSERT INTO spip_caches (naissance, texte, vetuste, process_ins, hache)
VALUES	(UNIX_TIMESTAMP(),'" . addslashes($texte) . "', $delais,'" . $page['process_ins'] . "',0x$cache)
");
    invalideur_de_cache($infosurpage['id_article'],'id_article', $cache);
    invalideur_de_cache($infosurpage['id_breve'],   'id_breve', $cache);
    invalideur_de_cache($infosurpage['id_rubrique'],'id_rubrique', $cache);
    }
}

function invalideur_de_cache($a, $type, $cache) {
  if (is_array($a))
    {
      $values = array();
      foreach($a as $k => $v)
	{ $m = "(0x$cache, $k)"; $values[] = $m; $l .= " $k";}
#      spip_log("cache $cache dpend des $type:$l");
      spip_query("
INSERT IGNORE INTO spip_" . $type . _SUFFIXE_DES_CACHES . "
(hache, " . $type . ")
VALUES " . join(", ", $values));
    }
}

// Regarde dans une table de nom de caches ceux vrifiant une condition donne
// Les retire de cette table et de la table gnrale des caches
// Si la condition est vide, c'est une simple purge gnrale

function update_cache($cond, $table)
{
  if (!$cond)
    {if ($table == "spip_squelettes")
	spip_query("
DELETE FROM spip_squelettes
");
      else if ($table == "spip_caches")
	{
	  spip_query("
DELETE FROM spip_caches
");
	  spip_query("
DELETE FROM spip_inclure" .  _SUFFIXE_DES_CACHES ."
");
	  foreach($spip_tables_principales as $a)
	    {
	      spip_query("
DELETE FROM spip_" . $GLOBALS[$a . '_key']["PRIMARY KEY"] . _SUFFIXE_DES_CACHES ."
");
	    }
	}
    }
  else
    {
      $result = spip_query("
SELECT  DISTINCT hache 
FROM    $table" . (!$cond ? '' : "
WHERE   $cond
"));
      $tous = '';
      while ($row = spip_fetch_array($result)) $tous[] = $row['hache'];
      supprime_cache_dependant($tous);
    }
}

function supprime_cache_dependant($tous)
{
  global $spip_tables_principales;
  if ($tous)
    {
      $tous = join(', ', $tous);
      $niveau = $tous;
      while ($niveau)
	{
# le NOT IN est thoriquement superflu, mais protge des tables endommages
	  $result = spip_query("
SELECT  DISTINCT hache
FROM    spip_inclure" . _SUFFIXE_DES_CACHES . "
WHERE   inclure IN ($niveau) 
AND	hache NOT IN ($tous)
");
	  $niveau = array();
	  while ($row = spip_fetch_array($result))
	    { $niveau[] = $row['hache']; $tous .= ", " . $row['hache'];}
	  $niveau = join(', ', $niveau);
	}
  spip_log("Destructions des caches: $tous");
      spip_query("
DELETE FROM spip_caches
WHERE hache IN ($tous)
");
      spip_query("
DELETE FROM spip_inclure
WHERE hache IN ($tous)
");
      foreach($spip_tables_principales as $a)
	{
	  spip_query("
DELETE FROM spip_" . $GLOBALS[$a . '_key']["PRIMARY KEY"] . _SUFFIXE_DES_CACHES ."
WHERE hache IN ($tous)
");
	}
    }
}

// invalide une arborscence de rubrique
function update_cache_rubrique($id_rubrique)
{
    while ($id_rubrique)
      {
	update_cache("id_rubrique='$id_rubrique'", spip_id_rubrique_caches);
	$r = spip_fetch_array(spip_query("
SELECT id_parent 
FROM spip_rubriques 
WHERE id_rubrique=$id_rubrique"));
	$id_rubrique = $r['id_parent'];
      }
}

?>
